# SoilTemp.bas
#  Program 4.1  Hot Paw BASIC program for
#    computing soil temperature and soil
#    heat flux
#
s$(2)="BD (Mg/m3)"
s$(3)="1.3"
s$(4)="wtr (m3/m3)"
s$(5)="0.2"
s$(6)="Clay %""
s$(7)="12"
s$(8)="avg T (C)"
s$(9)="20"
s$(10)="Ao (c)"
s$(11)="15"
s$(12)="t@Tmax (hr)"
s$(13)="12"
s$(14)="A/S bndry"
s$(15)="S"
s$(16)="To (A or #)"
s$(17)="A"
r%=form(12,0,"SoilTemp inputs")
if r%=0 then end
m=15
bd=val(s$(3))
wv=val(s$(5))
mc=val(s$(7))/100
ta=val(s$(9)): tb=ta
am=val(s$(11))
toffset=val(s$(13))-6
if (s$(15)="S") or (s$(15)="s") then Air$="f"
if (s$(15)="A") or (s$(15)="a") then Air$="t"
if (s$(17)="A") or (s$(17)="a") then 
   Tinitial$="a"
  else
    Tinitial$="n"
    Tinitial=val(s$(17))
endif
dim w(m+1),t(m+1),t0(m+1),tn(m+1),k(m+1)
dim cp(m),a(m+1),b(m),c(m),d(m),z(m+1)
for i=1 to m
 z(i+1)=z(i)+0.005*1.5^(i-1)
next
#  ti is time of day (hr)  dt is time step (sec)  da is day number
ti=0:  dt=3600:  da=0:  f=0.6:   g=1-f
c1=0.65-(0.78*bd)+(0.6*bd*bd)
c2=1.07*bd
c3=1+2.64/sqr(mc)
c4=0.03+(0.1*bd*bd)
if Air$="t" then k(0)=20
for i=1 to m
 cp(i)=(2400000*bd/2.65+4180000*wv)*(z(i+1)-z(i-1))/(2*dt)
 power=(c3*wv)^4
 k(i)=(c1+c2*wv-((c1-c4)*exp(-power)))
 k(i)=k(i)/(z(i+1)-z(i))
next
dfsvty=k(5)*(z(6)-z(5))
dfsvty=dfsvty/(2400000*bd/2.65+4180000*wv)
zd=sqr(2*dfsvty/7.3e-5)
for i=1 to m
  if Tinitial$="a" then
      t(i)=ta+(am*exp(-z(i)/zd)*sin((-0.261799*toffset)-z(i)/zd))
   else
     t(i)=Tinitial
  endif
  t0(i)=t(i)
next
t(m+1)=ta:  tn(m+1)=t(m+1)

newtime:
ti=ti+dt/3600
if ti=24 then   ti=ti-24:  da=da+1              
if Air$="t" then
   tn(0)=ta+am*sin(0.261799*(ti-toffset))
   lower=1
  else  
     tn(1)=ta+am*sin(0.261799*(ti-toffset))
     lower=2
endif
for i=lower to m
 c(i)=-k(i)*f
 a(i+1)=c(i)
 b(i)=f*(k(i)+k(i-1))+cp(i)
 d(i)=g*(k(i-1)*t(i-1)+k(i)*t(i+1))
 d(i)=d(i)+t(i)*(cp(i)-g*(k(i)+k(i-1)))
next
d(lower)=d(lower)+(k(lower-1)*tn(lower-1)*f)
d(m)=d(m)+(k(m)*f*tn(m+1))
for i=lower to m-1
 c(i)=c(i)/b(i)
 d(i)=d(i)/b(i)
 b(i+1)=b(i+1)-a(i+1)*c(i)
 d(i+1)=d(i+1)-a(i+1)*d(i)
next
tn(m)=d(m)/b(m)
for i=m-1 to lower step -1
 tn(i)=d(i)-(c(i)*tn(i+1))
next
for i=(lower-1) to m
 t(i)=tn(i)
next
if r%=1 then goto tabular
if r%=3 then goto plotTvt
if r%=2 then
   if (da=0) and (ti=1) then
       draw -1
       draw "ti="+str$(0)+"  ",0,15
       goto plotTvD
    else
       if ti=0 then  draw -1
       draw "ti="+str$(ti)+"    ",0,15
   endif
   if ti=0  then goto plotTvD
   if ti=6 then goto plotTvD
   if ti=12 then goto plotTvD
   if ti=18 then goto plotTvD
    else goto dayck
   endif
endif

dayck:
if da<4 
   goto newtime
  else 
   fn pen(0)
   end
endif

tabular:
# soiltemp tabular results
#include "# soiltemp tabular results"

plotTvD:
# TvD plotting routine
#include "# TvD plotting routine"

plotTvt:
# Tvt plotting routine
#include "# Tvt plotting routine"
